import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.win32.*;


/*
BIOS Data sample
Copyright (c) 1999-2004, Zeal SoftStudio
http://www.zealsoft.com
support@zealsoft.com
This sample demonstates how to use MemAccess Library to access the BIOS 
data.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register MemAccess Library,
		// place your registration information here.
		MemAccess.maLicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void btnClose_click(Object source, Event e)
	{
		this.close();
	}

	// Get the BIOS date
	public String GetBIOSDate()
	{
		int i;
		byte b;
		StringBuffer sBuffer = new StringBuffer(11);
    
		for(i = 1; i <= 10; i++)
		{
		    b = MemAccess.maPeekB(MemAccess.V86_To_PhyAddress('\uffff',(char)( i + 4)));
		    if(b == 0) 
				break;
		    sBuffer.append((char)b);
		}
		return sBuffer.toString();
	}
	
	private void btnGet_click(Object source, Event e)
	{
		StringBuffer sError = new StringBuffer(255);
    
		// Open the library
		if(!MemAccess.maOpenLibrary())
		{
		    MemAccess.maGetLastState(sError);
			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}
    

		listBox1.removeAll();
	
		int i, nAddress;
		String s;

		// COM ports
		for(i = 1; i <= 4; i++)
		{
			nAddress = MemAccess.maPeekW(0x400 + (i - 1) * 2);
			if(MemAccess.maGetLastState(sError) != MemAccess.ERROR_SUCCESS)
			{
			    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
				return;
			}
			else if(nAddress != 0)
			{
				s = "COM" + String.valueOf(i) + " : 0x" 
						+ Integer.toHexString(nAddress);
				listBox1.addItem(s);
			}
			else
			{
				s = "COM" + String.valueOf(i) + " : absent";
				listBox1.addItem(s);
			}
		}

		// LPT ports
		for(i = 1; i <= 3; i++)
		{
			nAddress = MemAccess.maPeekW(0x408 + (i - 1) * 2);
			if(MemAccess.maGetLastState(sError) != MemAccess.ERROR_SUCCESS)
			{
			    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
				return;
			}
			else if(nAddress != 0)
			{
				s = "LPT" + String.valueOf(i) + " : 0x" 
						+ Integer.toHexString(nAddress);
				listBox1.addItem(s);
			}
			else
			{
				s = "LPT" + String.valueOf(i) + " : absent";
				listBox1.addItem(s);
			}
		}

		label2.setText("BIOS Date: " + GetBIOSDate());

		// Close the library
		MemAccess.maCloseLibrary();
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	ListBox listBox1 = new ListBox();
	Label label2 = new Label();
	Label label3 = new Label();
	Button btnGet = new Button();
	Button btnClose = new Button();

	private void initForm()
	{
		label1.setLocation(new Point(8, 8));
		label1.setSize(new Point(152, 24));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("Port base address:");

		listBox1.setLocation(new Point(8, 24));
		listBox1.setSize(new Point(208, 112));
		listBox1.setTabIndex(1);
		listBox1.setText("listBox1");
		listBox1.setUseTabStops(true);

		label2.setLocation(new Point(8, 144));
		label2.setSize(new Point(288, 16));
		label2.setTabIndex(2);
		label2.setTabStop(false);
		label2.setText("");

		label3.setLocation(new Point(8, 168));
		label3.setSize(new Point(288, 16));
		label3.setTabIndex(3);
		label3.setTabStop(false);
		label3.setText("Copyright (c) 1999-2004, Zeal SoftStduio");

		btnGet.setLocation(new Point(224, 16));
		btnGet.setSize(new Point(75, 23));
		btnGet.setTabIndex(5);
		btnGet.setText("Get");
		btnGet.addOnClick(new EventHandler(this.btnGet_click));

		btnClose.setLocation(new Point(224, 48));
		btnClose.setSize(new Point(75, 23));
		btnClose.setTabIndex(4);
		btnClose.setText("Close");
		btnClose.addOnClick(new EventHandler(this.btnClose_click));

		this.setText("BIOSData Sample");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setBorderStyle(FormBorderStyle.FIXED_SINGLE);
		this.setCancelButton(btnClose);
		this.setClientSize(new Point(304, 194));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);
		this.setStartPosition(FormStartPosition.CENTER_SCREEN);

		this.setNewControls(new Control[] {
							btnClose, 
							btnGet, 
							label3, 
							label2, 
							listBox1, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
