import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.win32.*;
import com.ms.dll.*;

/*
maMapPhysToLinear sample
Copyright (c) 1999-2004, Zeal SoftStudio
http://www.zealsoft.com
support@zealsoft.com
This sample demonstates how to use maMapPhysToLinear function.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register MemAccess Library,
		// place your registration information here.
		MemAccess.maLicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void btnClose_click(Object source, Event e)
	{
		this.close();
	}

	private void btnGet_click(Object source, Event e)
	{
		StringBuffer sError = new StringBuffer(255);
    
		// Open the library
		if(!MemAccess.maOpenLibrary())
		{
		    MemAccess.maGetLastState(sError);			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}
		
		int[] h = new int[1];
		int p;
		String sAddr;
    
		// Map the physical address
		p = MemAccess.maMapPhysToLinear(0xFFFF5, 10, h);
		if(p == 0)
		{
		    MemAccess.maGetLastState(sError);			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}
    
		// Copy the BIOS date string from the linear address
		sAddr = DllLib.ptrToStringAnsi(p);
		label2.setText("BIOS date:" + sAddr);
    
		// Unmap the address
		MemAccess.maUnmapPhysicalMemory(h[0], p);

		// Close the library
		MemAccess.maCloseLibrary();
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Button btnGet = new Button();
	Label label2 = new Label();
	Label label3 = new Label();
	Button btnClose = new Button();

	private void initForm()
	{
		this.setText("maMapPhysToLinear Demo");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setClientSize(new Point(380, 129));

		label1.setForeColor(Color.RED);
		label1.setLocation(new Point(8, 16));
		label1.setSize(new Point(272, 56));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("CAUTION: Don\'t access any address which has not be mapped, or the system will crash and the unsaved data may lose.");

		btnGet.setLocation(new Point(296, 16));
		btnGet.setSize(new Point(75, 23));
		btnGet.setTabIndex(2);
		btnGet.setText("Get");
		btnGet.addOnClick(new EventHandler(this.btnGet_click));

		label2.setLocation(new Point(8, 72));
		label2.setSize(new Point(304, 24));
		label2.setTabIndex(3);
		label2.setTabStop(false);
		label2.setText("Press the Get button and see the result here!");

		label3.setLocation(new Point(8, 104));
		label3.setSize(new Point(360, 16));
		label3.setTabIndex(4);
		label3.setTabStop(false);
		label3.setText("Copyright (C) 1999-2004 Zeal SoftStudio.");

		btnClose.setLocation(new Point(296, 48));
		btnClose.setSize(new Point(75, 23));
		btnClose.setTabIndex(1);
		btnClose.setText("Close");
		btnClose.addOnClick(new EventHandler(this.btnClose_click));

		this.setNewControls(new Control[] {
							btnClose, 
							label3, 
							label2, 
							btnGet, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
