/*
MemAccess Library for Visual J++ 6.0
Copyright (c) 1999-2004 Hai Li, Zeal SoftStudio.
E-Mail: support@zealsoft.com
Web: http://www.zealsoft.com
*/

public class MemAccess
{
	public static class BADDR
	{
		public int BaseAddress;
		public int Size;
		public int IOType;
	}

	public static int V86_To_PhyAddress(char seg, char ofs)
	{
		return seg << 4 | ofs;
	}

	// Determine whether the program is running under WinNT.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maIsWinNT();

	// Open the diver.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maOpenLibrary();

	// Close the driver.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maCloseLibrary();

	// Return a byte word at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static byte  maPeekB(int nAddress);
	// Return a word at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static short maPeekW(int nAddress);
	// Return a double word at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static int  maPeekD(int nAddress);

	// Store a byte at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maPokeB(int nAddress, short nData);
	// Store a word at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maPokeW(int nAddress, short nData);
	// Store a double word at memory location nAddress.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maPokeD(int nAddress, int dwData);

	// Set the registration information.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static void  maLicenseInfo(String sUser, int dwKey);

	// Error constants
	public static final int ERROR_SUCCESS = 0;
	public static final int ERROR_MA_DRIVER = 2;
	public static final int ERROR_MA_NO_DEVICE_HANDLE = 9996;
	public static final int ERROR_MA_SCM_CANT_CONNECT = 9998;

	// Returns a value indicating the last operation is successful or not.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static int  maGetLastState(StringBuffer s);

	// Returns the version of MemAccess Library.
	/** @dll.import("MemAcc.dll", ansi) */
	public native static short  maGetVersion();

	// Install the service under Windows NT/2000/XP
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maInstallService();
	// Remove the service under Windows NT/2000/XP
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maRemoveService();
	// Control the service under Windows NT/2000/XP
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maControlService();

	// Map the physical address to process address
	/** @dll.import("MemAcc.dll", ansi) */
	public native static int maMapPhysToLinear(int PhsAddr, int dwSize, int[] hMem);

	// Unmap the address
	/** @dll.import("MemAcc.dll", ansi) */
	public native static boolean  maUnmapPhysicalMemory(int hMem, int LinearAddr);

	// Get the base address of a PCI device
	/** @dll.import("MemAcc.dll", ansi) */
	public native static int  maGetDeviceBaseAddress(short[] VendorID, short[] DeviceID, int nIndex, int [] baddrPtr);
	
}

