import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.win32.*;

/*
MemAccess Library sample
Copyright (c) 1999-2004, Zeal SoftStudio
http://www.zealsoft.com
support@zealsoft.com
This sample demonstates how to use MemAccess Library to read 256 bytes.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register MemAccess Library,
		// place your registration information here.
		MemAccess.maLicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void button2_click(Object source, Event e)
	{
		this.close();
	}

	private void btnRead_click(Object source, Event e)
	{
		int nAddr;

		nAddr = Integer.valueOf(edit1.getText(), 16).shortValue();
    
		StringBuffer sError = new StringBuffer(255);
		// Open the library
		if(!MemAccess.maOpenLibrary())
		{
		    MemAccess.maGetLastState(sError);			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}

		// Read 256 bytes
		StringBuffer s = new StringBuffer(1000);
		String sNumber;
		for(int i = 0; i < 256; i++)
		{
			sNumber = Integer.toHexString(MemAccess.maPeekB(nAddr + i) + 128);
			if(sNumber.length() == 1)
				s.append("0");
			s.append(sNumber + " ");
			if(i % 16 == 15)
				s.append("\r\n");
		}
		edit2.setText(s.toString());
    
		// Close the library
		MemAccess.maCloseLibrary();		
		
	}

	private void btnWrite_click(Object source, Event e)
	{
		int nAddr;

		nAddr = Integer.valueOf(edit1.getText(), 16).shortValue();
		
		StringBuffer sError = new StringBuffer(255);
    
		// Open the library
		if(!MemAccess.maOpenLibrary())
		{
		    MemAccess.maGetLastState(sError);			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}
      
		// Write 256 bytes
		for(int i = 0; i < 256; i++)
		{
			MemAccess.maPokeB(nAddr + i, (short)i);
		}
    
		// Close the library
		MemAccess.maCloseLibrary();		
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Edit edit1 = new Edit();
	Button btnRead = new Button();
	Button btnWrite = new Button();
	Button btnClose = new Button();
	Edit edit2 = new Edit();

	private void initForm()
	{
		this.setText("MemTest Sample");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setBorderStyle(FormBorderStyle.FIXED_SINGLE);
		this.setClientSize(new Point(422, 284));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);

		label1.setLocation(new Point(8, 16));
		label1.setSize(new Point(100, 23));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("Address(hex):");

		edit1.setLocation(new Point(96, 16));
		edit1.setSize(new Point(72, 19));
		edit1.setTabIndex(1);
		edit1.setText("F8000");

		btnRead.setLocation(new Point(192, 16));
		btnRead.setSize(new Point(64, 24));
		btnRead.setTabIndex(4);
		btnRead.setText("Read");
		btnRead.addOnClick(new EventHandler(this.btnRead_click));

		btnWrite.setLocation(new Point(264, 16));
		btnWrite.setSize(new Point(64, 24));
		btnWrite.setTabIndex(3);
		btnWrite.setText("Write");
		btnWrite.addOnClick(new EventHandler(this.btnWrite_click));

		btnClose.setLocation(new Point(336, 16));
		btnClose.setSize(new Point(64, 24));
		btnClose.setTabIndex(2);
		btnClose.setText("Close");
		btnClose.addOnClick(new EventHandler(this.button2_click));

		edit2.setFont(new Font("Courier New", 12.0f, FontSize.CHARACTERHEIGHT, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
		edit2.setLocation(new Point(16, 56));
		edit2.setSize(new Point(392, 216));
		edit2.setTabIndex(5);
		edit2.setText("");
		edit2.setMultiline(true);
		edit2.setScrollBars(ScrollBars.VERTICAL);

		this.setNewControls(new Control[] {
							edit2, 
							btnClose, 
							btnWrite, 
							btnRead, 
							edit1, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
