import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.win32.*;
import com.ms.dll.*;

/*
PCI Sample
Copyright (c) 1999-2004, Zeal SoftStudio
http://www.zealsoft.com
support@zealsoftstudio.com
This sample demonstates how to use MemAccess Library to get the base 
address of a PCI device.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register MemAccess Library,
		// place your registration information here.
		MemAccess.maLicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}


	private void btnCancel_click(Object source, Event e)
	{
		close();
	}

	private void btnOK_click(Object source, Event e)
	{
		final int BADDR_COUNT = 6;
		// Three int members in BADDR class
		final int INT_SIZE_BADDR = 3;
		String sDeviceID, sVendorID;
		sDeviceID = edit1.getText();
		sVendorID = edit2.getText();
		if(sDeviceID == "" || sVendorID == "")
		{
		    User32.MessageBox(getHandle(),
							  "Please input the DeviceID and VendorID!", 
							  "Error", win.MB_ICONHAND);
		    return;
		}
     
		StringBuffer sError = new StringBuffer(255);
    
		// Open the library
		if(!MemAccess.maOpenLibrary())
		{
		    MemAccess.maGetLastState(sError);			
		    User32.MessageBox(getHandle(), sError.toString(), "Error", win.MB_ICONHAND);
		    return;
		}
    
		MemAccess.BADDR baddrAddress = new MemAccess.BADDR();
		int nResult, nIndex;
		int i;
		int[] baddrPtr = new int[BADDR_COUNT * INT_SIZE_BADDR];
		short[] VendorID = new short[1];
		short[] DeviceID = new short[1];
		String s;
		StringBuffer sResult = new StringBuffer(5000);
    
		// Enumerate all devices
		nIndex = 0;
		edit3.clear();
		do
		{
			VendorID[0] = Integer.valueOf(sVendorID, 16).shortValue();
			DeviceID[0] = Integer.valueOf(sDeviceID, 16).shortValue();
		    nResult = MemAccess.maGetDeviceBaseAddress(VendorID, DeviceID, 
													   nIndex, baddrPtr);
		    switch(nResult)
			{
		    case 1: // A device found
		        sResult.append("VendorID: 0x" 
							   + Integer.toHexString(VendorID[0] & 0xffff)
							   + " DeviceID: 0x" 
							   + Integer.toHexString(DeviceID[0] & 0xffff)
							   + "\r\n");
		        for(i = 0; i < BADDR_COUNT; i++)
				{
					baddrAddress.BaseAddress = baddrPtr[i * INT_SIZE_BADDR];
					baddrAddress.Size = baddrPtr[i * INT_SIZE_BADDR + 1];
					baddrAddress.IOType = baddrPtr[i * INT_SIZE_BADDR + 2];
					if(baddrAddress.IOType != 2)
					{
						sResult.append("   Address(" + Integer.toString(i) +  "): 0x"
									   + Integer.toHexString(baddrAddress.BaseAddress)
									   + " - 0x" 
									   + Integer.toHexString(baddrAddress.BaseAddress 
															 + baddrAddress.Size - 1) 
									   + "\r\n");
						sResult.append("      " + 
									 (baddrAddress.IOType == 1?"Port I/O":"Memory I/O") 
									   + "\r\n");
					}
		        }
		        sResult.append("\r\n");
				break;
		    case 0: // Error
			    MemAccess.maGetLastState(sError);			
		        sResult.append("Error :" + sError.toString());
				break;
		    case -1: // No device found
		        if(sResult.length() == 0)
				{
		            sResult.append("No device found.");
				}
			}
		    nIndex = nIndex + 1;
			edit3.setText(sResult.toString());
		}
		while(nResult == 1);

		// Close the library
		MemAccess.maCloseLibrary();
		
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Label label2 = new Label();
	Edit edit1 = new Edit();
	Label label3 = new Label();
	Edit edit2 = new Edit();
	Button btnOK = new Button();
	Button btnCancel = new Button();
	Edit edit3 = new Edit();

	private void initForm()
	{
		label1.setLocation(new Point(16, 232));
		label1.setSize(new Point(296, 16));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("Copyright (C) 1999-2004 Zeal SoftStudio.");

		label2.setLocation(new Point(16, 16));
		label2.setSize(new Point(64, 16));
		label2.setTabIndex(3);
		label2.setTabStop(false);
		label2.setText("Vendor ID:");

		edit1.setLocation(new Point(80, 16));
		edit1.setSize(new Point(48, 19));
		edit1.setTabIndex(4);
		edit1.setText("FFFF");

		label3.setLocation(new Point(136, 16));
		label3.setSize(new Point(72, 16));
		label3.setTabIndex(1);
		label3.setTabStop(false);
		label3.setText("Device ID:");

		edit2.setLocation(new Point(208, 16));
		edit2.setSize(new Point(48, 19));
		edit2.setTabIndex(2);
		edit2.setText("FFFF");

		btnOK.setLocation(new Point(360, 16));
		btnOK.setSize(new Point(80, 24));
		btnOK.setTabIndex(6);
		btnOK.setText("OK");
		btnOK.addOnClick(new EventHandler(this.btnOK_click));

		btnCancel.setLocation(new Point(360, 48));
		btnCancel.setSize(new Point(80, 24));
		btnCancel.setTabIndex(5);
		btnCancel.setText("Cancel");
		btnCancel.addOnClick(new EventHandler(this.btnCancel_click));

		this.setText("PCI Sample");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setBorderStyle(FormBorderStyle.FIXED_SINGLE);
		this.setCancelButton(btnCancel);
		this.setClientSize(new Point(445, 253));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);

		edit3.setLocation(new Point(16, 40));
		edit3.setSize(new Point(336, 184));
		edit3.setTabIndex(7);
		edit3.setText("");
		edit3.setMultiline(true);
		edit3.setScrollBars(ScrollBars.BOTH);

		this.setNewControls(new Control[] {
							edit3, 
							btnCancel, 
							btnOK, 
							edit2, 
							label3, 
							edit1, 
							label2, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
